class "BasePoke" {
	hp=100,orig=100,name="Base",user=true,enemy=false,level=1,attack1='punch',attack2='punch',attack3='punch',attack4='punch',pic='vagikarp.png',bpic='vagikarpb.png',y=0,n=0,points=0,lvlpoints=100,savename=''
}
BasePoke.species = {} -- new field to keep track of all species created
function BasePoke:__init(hp,orig,name,user,enemy,level,attack1,attack2,attack3,attack4,pic,bpic,y,n)--Sets how you would name a custom pokemon
	self.hp=hp
	self.name=name
	self.user=user
	self.enemy=enemy
	self.level=level
	self.attack1=attack1
	self.attack2=attack2
	self.attack3=attack3
	self.attack4=attack4
	self.pic=pic
	self.orig=orig
	self.bpic=bpic
	self.y=y
	self.n=n
	self.savename=''
	self.savelevel=''
	self.savepic=''
	self.savebpic=''
	self.saveattack1=''
	self.saveattack2=''
	self.saveattack3=''
	self.saveattack4=''
	table.insert(BasePoke.species,self)
end
function BasePoke:draw()--Pokemon draw
	local e=love.filesystem.exists(self.pic)
	local a=love.filesystem.exists(self.bpic)
	if gamestate=='pokeselect' then
		love.graphics.print('level:'..self.level,font:getWidth(self.name)+6,self.y)--prints level
		if self.user==true then
			love.graphics.print('*',font:getWidth(self.name)+font:getWidth('level:'..self.level)+5,self.y)--indicates user-ness by drawing *
		end
		if self.enemy==true then
			love.graphics.print('+',font:getWidth(self.name)+font:getWidth('level:'..self.level)+5,self.y)--indicates enemy-ness by drawing +
		end
		if self.n==pokeselect then
			love.graphics.print('['..self.name..']',0,self.y)--show which pokemon you are selecting
		else
			love.graphics.print(self.name,0,self.y)--if not selected....
		end
	end
	if gamestate=='fight' then
		if self.user==true then
			love.graphics.print(self.name,85,122)--draw's user name
			if a then--checks if picture exists
				love.graphics.draw(love.graphics.newImage(self.bpic),0,120)--it does!
			else
				love.graphics.draw(love.graphics.newImage('graphics/vagikarpb.png'),0,120)--it doesn't :(
			end
			love.graphics.rectangle('fill',85,136,self.hp*.5,4)--health bar
			love.graphics.print('lvl:'..self.level,90+(font:getWidth(self.name)),122)--level level level
		end
		if self.enemy==true then--like user, but enemy.
			love.graphics.print(self.name,85,2)
			if e then
				love.graphics.draw(love.graphics.newImage(self.pic),100,22)
			else
				love.graphics.draw(love.graphics.newImage('graphics/vagikarp.png'),100,22)
			end
			love.graphics.rectangle('fill',85,16,self.hp*.5,4)
			love.graphics.print('lvl:'..self.level,90+(font:getWidth(self.name)),2)
		end
	end
	if gamestate=='customize' then
		if self.user==true then
			love.graphics.print(self.name,0,0)
		end
	end
end
function BasePoke:clear()
	enemyselected=false
	self.hp=self.orig
end	
function BasePoke:update()
	local readshit=love.filesystem.exists('blank.txt')--checks.
	local blank=''
	if self.level=='1' then--if you edit your level to be above 7, your game will break.
		self.level=1
	end
	if self.level=='2' then
		self.level=2 
	end
	if self.level=='3' then
		self.level=3
	end
	if self.level=='4' then
		self.level=4
	end
	if self.level=='5' then
		self.level=5
	end
	if self.level=='6' then
		self.level=6
	end
	if self.level=='7' then
		self.level=7
	end
	if self.user==true and load==true then
		if readshit then--IF YOU DELETE ANY OF THESE FILES, YOUR GAME WILL BREAK.
			self.name = love.filesystem.read('name.txt',all)
			self.level = love.filesystem.read('level.txt',all)
			self.pic = love.filesystem.read('pic.txt',all)
			self.bpic = love.filesystem.read('bpic.txt',all)
			self.attack1 =love.filesystem.read('attack1.txt',all)
			self.attack2 =love.filesystem.read('attack2.txt',all)
			self.attack3 =love.filesystem.read('attack3.txt',all)
			self.attack4 =love.filesystem.read('attack4.txt',all)
			load=false
		else
			load=false
		end
	end
	if save==true then
		if self.user==true then--writes data to files.
			self.savename = love.filesystem.write('name.txt',self.name,all)	
			self.savelevel = love.filesystem.write('level.txt',self.level,all)
			self.savepic = love.filesystem.write('pic.txt',self.pic,all)
			self.savebpic = love.filesystem.write('bpic.txt',self.bpic,all)
			self.saveattack1 = love.filesystem.write('attack1.txt',self.attack1,all)
			self.saveattack2 = love.filesystem.write('attack2.txt',self.attack2,all)
			self.saveattack3 = love.filesystem.write('attack3.txt',self.attack3,all)
			self.saveattack4 = love.filesystem.write('attack4.txt',self.attack4,all)
			blank = love.filesystem.write('blank.txt','do not delete',all)
			save=false
		end
	end
	if runtry==true then--Makes it so if you run, you can select again.
		self:clear()
	end
	if customize==true then
		if self.n==pokeselect then
			self.name=name
		end
	end
	if self.n==pokeselect then--selection!
		if userselect==true and self.enemy==false then
			self.user=true
			userselect=false
		end
		if enemyselect==true and self.user==false then
			self.enemy=true
			enemyselect=false
		end
	end
	if user.item=='rare candy' then
		if self.user==true then
			self.level=self.level+1
		end
	end
	if gamestate=='adventure' then
		self.enemy=false
	end
	if self.user==true then
		checknum=self.n
	end
	if gamestate=='fight' then
		if fight==true then--This fight system is a lil messy.  Lemme explain.
			if self.user==true then
				user.attackname[1]=self.attack1--This means that the player's attack=pokemon's attack
				user.attackname[2]=self.attack2
				user.attackname[3]=self.attack3
				user.attackname[4]=self.attack4
				if self.level<=6 and self.level>2 then--this is so attack power increases with level.
					user.attack[n]=user.attack[n]*self.level/3
				else
					if self.level>6 then--if level gets too big, then it becomes a standard attack rate
						user.attack[n]=user.attack[n]*2
					else
						user.attack[n]=user.attack[n]--if level=1 or 2.
					end
				end
				if enemy.attacking==true then 
					self.hp=self.hp-enemy.attack[p]--Where the damage is inflicted.  The rest is in battle.lua
				end
			end
			if self.enemy==true then
				enemy.attackname[1]=self.attack1--sets attacks
				enemy.attackname[2]=self.attack2
				enemy.attackname[3]=self.attack3
				enemy.attackname[4]=self.attack4
				if self.level<=6 and self.level>2 then--oohhh multiplying attacks
					enemy.attack[p]=enemy.attack[p]*self.level/3
				else
					if self.level>6 then
						enemy.attack[p]=enemy.attack[p]*2
					else
						enemy.attack[p]=enemy.attack[p]
					end
				end
				if user.attacking==true then--duh.
					self.hp=self.hp-user.attack[n]
				end
			end
		end
	end
	self:levelup()
	if self.hp<=0 then
		self:faint()
	end
end
function BasePoke:levelup()--LEVELUP'
	if self.level==8 then
			self:clear()
			self.level=1
			gamestate='pokeselect'
		end
	if self.user==true and user.win==true and enemy.lose==true or self.enemy==true and enemy.win==true and user.lose==true then--really big shit right here, checks to see if someone won the fight.
		if self.level<=6 and self.level>2 then--increasing health!
			self.hp=self.orig*self.level/3
		else
			if self.level>6 then
				self.hp=self.orig*2
			else
				self.hp=self.orig--awww level isn't high enough :(
			end
		end
		user.win=false
		user.lose=false
		self.level=self.level+1
		runtry=true
	end
end
function BasePoke:faint()--Self explanatory.
	runtry=true
	if self.level<=6 and self.level>2 then
			self.hp=self.orig*self.level/3
		else
			if self.level>6 then
				self.hp=self.orig*2
			else
				self.hp=self.orig
			end
		end--yes, i did copy/paste this.
	if self.user==true then
		user.lose=true
	end
	if self.user==false then
		user.win=true
	end
end
--shit load  of shit
Luna=BasePoke:new(100,100,"Princess Luna",false,false,1,"permabanned","slap",'punch','bitch',"graphics/luna.png","graphics/lunab.png",112,9)
Rainbow=BasePoke:new(100,100,"Rainbow Dash",false,false,1,"sonic rainboom","slap",'fly','bitch',"graphics/rainbow.png","graphics/rainbowb.png",98,8)
Pinkie=BasePoke:new(100,100,"Pinke Pie",false,false,1,"party cannon","slap",'punch','rape',"graphics/pinkie.png","graphics/pinkieb.png",84,7)
Fluttershy=BasePoke:new(100,100,"Fluttershy",false,false,1,"fly","shy",'flutter','shout',"graphics/fluttershy.png","graphics/fluttershyb.png",70,6)
--[[Lawnboy=BasePoke:new(100,100,"Lawnboy",false,false,1,"rape","bitch",'permabanned','punch',"graphics/lawnboy.png","graphics/lawnboyb.png",126,10)
Saso=BasePoke:new(100,100,"Saso",false,false,1,"bitch","permabanned",'slap','punch',"graphics/saso.png","graphics/sasob.png",112,9)
Trosh=BasePoke:new(100,100,"Trosh",false,false,1,"punch","slap",'bitch','rape',"graphics/trosh.png","graphics/troshb.png",98,8)
Kyle=BasePoke:new(100,100,"Kyle Prior",false,false,1,"permabanned","slap",'party cannon','rape','graphics/kyle.png','graphics/kyleb.png',84,7)
Maurice=BasePoke:new(100,100,"Maurice",false,false,1,"bitch","punch",'sonic rainboom','rape','graphics/maurice.png','graphics/mauriceb.png',70,6)
]]
Bitchachu=BasePoke:new(100,100,"Bitchachu",false,false,1,'bitch','slap','punch','rape','graphics/bitchachu.png','graphics/bitchachub.png',28,3)
Fapdos=BasePoke:new(100,100,"Fapdos",false,false,1,'punch','slap','bitch','party cannon','graphics/punchdos.png','graphics/punchdosb.png',42,4)
Shoe=BasePoke:new(100,100,"Shoe",false,false,1,'kick','slap','punch','stomp','graphics/shoe.png','graphics/shoeb.png',56,5)
Vagikarp=BasePoke:new(100,100,"Vagikarp",false,false,1,'punch','slap','bitch','permabanned','graphics/vagikarp.png','graphics/vagikarpb.png',0,1)--"Sorry, you're a failure as a human, here, take this vagicarp"-camewel
Twattle=BasePoke:new(100,100,"Twattle",false,false,1,'punch','slap','party cannon','bitch','graphics/twattle.png','graphics/twattleb.png',14,2)
--CustomPoke=BasePoke:new(nil,nil,"Name",false,false,nil,'attack','attack','attack','attack','attack',pic.png','backpic.png',nil,nil)
